using Microsoft.AspNetCore.Mvc;

namespace WebApplication10.Controllers;

[ApiController]
[Route("[controller]")]
public class BooksController: ControllerBase
{
    private readonly BookShelf _bookShelf;

    public BooksController(BookShelf bookShelf)
    {
        _bookShelf = bookShelf;
    }
    
    [HttpGet]
    [Route("all")]
    public IEnumerable<Book> GetAll()
    {
        return _bookShelf.GetAll();
    }

    [HttpPost]
    [Route("add")]
    public IActionResult Add([FromBody] Book book)
    {
        var newBook = _bookShelf.Add(book);
        return new OkObjectResult(newBook);
    }
    
    [HttpPut]
    [Route("update")]
    public IActionResult Update([FromBody] Book book)
    {
        var res = _bookShelf.Update(book);
        return res ? new OkResult() : new BadRequestResult();
    }
    
    [HttpDelete]
    [Route("delete/{id}")]
    public IActionResult Delete(int id)
    {
        _bookShelf.Delete(id);
        return new OkResult();
    }
}